
import re
import traceback
from rusty.events import Event
from rusty.views import View
from rusty.http import Response
from rusty.authentication import User
from rusty.decorators import serialize
from rusty.jason import JasonEncoder

# TODO: Implement as EventSourceResponseWriter!

class EventListener(object):
    def __init__(self, connection, users=(), types=()):
        self.connection = connection
        self.users = users
        self.types = types
        
    # How to check if headers are sent?!
    def publish(self, event):
        try:
            buf = "event: %s\ndata: %s\n\n" % (
                event._get_name(),
                ExtendedEncoder().encode(event.serialize()))
            self.connection.handle.sendall(buf)
        except Exception, e:
            
            print traceback.format_exc()
            self.connection = None

class EventSourceView(View):
    def create(self, request):
        Event(**request.arguments)
        return Response("hoy")        
        
    def retrieve(self, request, users=(), types=()):
        listener = EventListener(request.connection, users, types)
        Event.objects.created.connect(listener.publish)
        return Response(headers={
            "Content-Type": "text/event-stream",
            "Cache-Control": "no-cache",
            "Access-Control-Allow-Origin": "*" })

    @serialize(mimetype="application/schema+json")
    def schema(self, request):
        event_schemas = {}
        for subclass in Event.get_subclasses():
            event_schemas[subclass._get_name()]= subclass.schema()
        return {
            "events":event_schemas}

