
class Signal:
    def __init__(self, memorize=False):
        self.slots = ()
        self.memorize = memorize
        self.backlog = ()
        self.enabled = True

    def connect(self, slot):
        self.slots += slot,
        if self.memorize:
            for slot in self.slots:
                for args, kwargs in self.backlog:
                    slot(*args, **kwargs)

    def emit(self, *args, **kwargs):
        if not self.enabled:
            return
        if self.memorize:
            self.backlog += (args, kwargs),
        for slot in self.slots:
            slot(*args, **kwargs)
            
    def __repr__(self):
        return "<Signal slots=%s>" % (self.slots,)
        
    def __iadd__(self, slot):
        self.connect(slot)
        return self
